;/*************************************************
;*       Perl-Compatible Regular Expressions      *
;*************************************************/
;
;           Copyright (c) 1997-2004 University of Cambridge
;
;-----------------------------------------------------------------------------
;Redistribution and use in source and binary forms, with or without
;modification, are permitted provided that the following conditions are met:
;
;    * Redistributions of source code must retain the above copyright notice,
;      this list of conditions and the following disclaimer.
;
;    * Redistributions in binary form must reproduce the above copyright
;      notice, this list of conditions and the following disclaimer in the
;      documentation and/or other materials provided with the distribution.
;
;    * Neither the name of the University of Cambridge nor the names of its
;      contributors may be used to endorse or promote products derived from
;      this software without specific prior written permission.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
;AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
;LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
;CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
;SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
;INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
;CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
;ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;POSSIBILITY OF SUCH DAMAGE.
;-----------------------------------------------------------------------------


;PCRE_MAJOR          @PCRE_MAJOR@
;PCRE_MINOR          @PCRE_MINOR@
;PCRE_DATE           @PCRE_DATE@


PCRE_CASELESS           equ 0001h
PCRE_MULTILINE          equ 0002h
PCRE_DOTALL             equ 0004h
PCRE_EXTENDED           equ 0008h
PCRE_ANCHORED           equ 0010h
PCRE_DOLLAR_ENDONLY     equ 0020h
PCRE_EXTRA              equ 0040h
PCRE_NOTBOL             equ 0080h
PCRE_NOTEOL             equ 0100h
PCRE_UNGREEDY           equ 0200h
PCRE_NOTEMPTY           equ 0400h
PCRE_UTF8               equ 0800h
PCRE_NO_AUTO_CAPTURE    equ 1000h
PCRE_NO_UTF8_CHECK      equ 2000h
PCRE_AUTO_CALLOUT       equ 4000h
PCRE_PARTIAL            equ 8000h

;/* Exec-time and get/set-time error codes */

PCRE_ERROR_NOMATCH        equ  (-1)
PCRE_ERROR_NULL           equ  (-2)
PCRE_ERROR_BADOPTION      equ  (-3)
PCRE_ERROR_BADMAGIC       equ  (-4)
PCRE_ERROR_UNKNOWN_NODE   equ  (-5)
PCRE_ERROR_NOMEMORY       equ  (-6)
PCRE_ERROR_NOSUBSTRING    equ  (-7)
PCRE_ERROR_MATCHLIMIT     equ  (-8)
PCRE_ERROR_CALLOUT        equ  (-9)  ;/* Never used by PCRE itself */
PCRE_ERROR_BADUTF8        equ (-10)
PCRE_ERROR_BADUTF8_OFFSET equ (-11)
PCRE_ERROR_PARTIAL        equ (-12)
PCRE_ERROR_BADPARTIAL     equ (-13)
PCRE_ERROR_INTERNAL       equ (-14)
PCRE_ERROR_BADCOUNT       equ (-15)

;/* Request types for pcre_fullinfo() */

PCRE_INFO_OPTIONS           equ  0
PCRE_INFO_SIZE              equ  1
PCRE_INFO_CAPTURECOUNT      equ  2
PCRE_INFO_BACKREFMAX        equ  3
PCRE_INFO_FIRSTBYTE         equ  4
PCRE_INFO_FIRSTCHAR         equ  4  ;/* For backwards compatibility */
PCRE_INFO_FIRSTTABLE        equ  5
PCRE_INFO_LASTLITERAL       equ  6
PCRE_INFO_NAMEENTRYSIZE     equ  7
PCRE_INFO_NAMECOUNT         equ  8
PCRE_INFO_NAMETABLE         equ  9
PCRE_INFO_STUDYSIZE         equ 10
PCRE_INFO_DEFAULT_TABLES    equ 11

;/* Request types for pcre_config() */

PCRE_CONFIG_UTF8                    equ 0
PCRE_CONFIG_NEWLINE                 equ 1
PCRE_CONFIG_LINK_SIZE               equ 2
PCRE_CONFIG_POSIX_MALLOC_THRESHOLD  equ 3
PCRE_CONFIG_MATCH_LIMIT             equ 4
PCRE_CONFIG_STACKRECURSE            equ 5
PCRE_CONFIG_UNICODE_PROPERTIES      equ 6

;/* Bit flags for the pcre_extra structure */

PCRE_EXTRA_STUDY_DATA          equ 0001h
PCRE_EXTRA_MATCH_LIMIT         equ 0002h
PCRE_EXTRA_CALLOUT_DATA        equ 0004h
PCRE_EXTRA_TABLES              equ 0008h

;/* Types */

;struct real_pcre;                 /* declaration; the definition is private  */
;typedef struct real_pcre pcre;

;/* The structure for passing additional data to pcre_exec(). This is defined in
;such as way as to be extensible. Always add new fields at the end, in order to
;remain compatible. */

;typedef struct pcre_extra {
;  unsigned long int flags;        /* Bits for which fields are set */
;  void *study_data;               /* Opaque data from pcre_study() */
;  unsigned long int match_limit;  /* Maximum number of calls to match() */
;  void *callout_data;             /* Data passed back in callouts */
;  const unsigned char *tables;    /* Pointer to character tables */
;} pcre_extra;

;/* The structure for passing out data via the pcre_callout_function. We use a
;structure so that new fields can be added on the end in future versions,
;without changing the API of the function, thereby allowing old clients to work
;without modification. */

;typedef struct pcre_callout_block {
;  int          version;           /* Identifies version of block */
;  /* ------------------------ Version 0 ------------------------------- */
;  int          callout_number;    /* Number compiled into pattern */
;  int         *offset_vector;     /* The offset vector */
;  const char  *subject;           /* The subject being matched */
;  int          subject_length;    /* The length of the subject */
;  int          start_match;       /* Offset to start of this match attempt */
;  int          current_position;  /* Where we currently are in the subject */
;  int          capture_top;       /* Max current capture */
;  int          capture_last;      /* Most recently closed capture */
;  void        *callout_data;      /* Data passed in with the call */
;  /* ------------------- Added for Version 1 -------------------------- */
;  int          pattern_position;  /* Offset to next item in the pattern */
;  int          next_item_length;  /* Length of next item in the pattern */
;  /* ------------------------------------------------------------------ */
;} pcre_callout_block;



pcre_compile proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_config proto c :DWORD,:DWORD
pcre_copy_named_substring proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_copy_substring proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_exec proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_free_substring proto c :DWORD
pcre_free_substring_list proto c :DWORD
pcre_fullinfo proto c :DWORD,:DWORD,:DWORD,:DWORD
pcre_get_named_substring proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_get_stringnumber proto c :DWORD,:DWORD
pcre_get_substring proto c :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
pcre_get_substring_list proto c :DWORD,:DWORD,:DWORD,:DWORD
pcre_info proto c :DWORD,:DWORD,:DWORD
pcre_maketables proto c
pcre_study proto c :DWORD,:DWORD,:DWORD
pcre_version proto c

